package com.jwl.driver.server.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.jwl.driver.server.constant.Constants;
import com.jwl.driver.server.dto.QuestionQueryDto;
import com.jwl.driver.server.entity.TdQuestion;
import com.jwl.driver.server.mapper.TdQuestionMapper;
import com.jwl.driver.server.service.ITdQuestionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jwl.driver.server.service.ITdSysConfigService;
import com.jwl.driver.server.vo.QusetionCategoryVo;
import com.jwl.driver.server.vo.QusetionVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 题库; 服务实现类
 * </p>
 *
 * @author Automated procedures
 * @since 2023-08-10
 */
@Service
public class TdQuestionServiceImpl extends ServiceImpl<TdQuestionMapper, TdQuestion> implements ITdQuestionService {

    @Autowired
    private ITdSysConfigService configService;

    @Override
    public TdQuestion queryQuestionById(QuestionQueryDto queryDto) {
        return this.getBaseMapper().selectById(queryDto.getQuestionId());
    }

    @Override
    public List<TdQuestion> queryQuestionByIdList(QuestionQueryDto queryDto) {
        LambdaQueryWrapper<TdQuestion> queryWrapper = new LambdaQueryWrapper<TdQuestion>()
                .in(TdQuestion::getQuestionId,queryDto.getQuestionIdList());

        return this.getBaseMapper().selectList(queryWrapper);
    }

    @Override
    public List<QusetionVo> queryQuestion(QuestionQueryDto queryDto) {
        return this.getBaseMapper().queryQuestion(queryDto);
    }

    @Override
    public List<QusetionVo> getTestQuestion(QuestionQueryDto queryDto) {
        List<QusetionVo> resultList = new ArrayList<>();

        if (StrUtil.equals(Constants.SUBJECT_ONE,queryDto.getSubject())){
            //40道判断题 60道单选 每题1分
            queryDto.setType(Constants.QUESTION_TYPE_ONE)
                    .setNum(60);
            resultList.addAll(this.getBaseMapper().queryQuestionByRandom(queryDto));

            queryDto.setType(Constants.QUESTION_TYPE_TWO)
                    .setNum(40);
            resultList.addAll(this.getBaseMapper().queryQuestionByRandom(queryDto));

        }else if(StrUtil.equals(Constants.SUBJECT_FOUR,queryDto.getSubject())){
            //20道判断题 20道单选 10道多选，每题2分，如果各车型不统一 可以配在数据库里
            queryDto.setType(Constants.QUESTION_TYPE_TWO)
                    .setNum(20);

            resultList.addAll(this.getBaseMapper().queryQuestionByRandom(queryDto));
            queryDto.setType(Constants.QUESTION_TYPE_ONE)
                    .setNum(20);

            resultList.addAll(this.getBaseMapper().queryQuestionByRandom(queryDto));
            queryDto.setType(Constants.QUESTION_TYPE_THREE)
                    .setNum(10);
            resultList.addAll(this.getBaseMapper().queryQuestionByRandom(queryDto));
        }
        return resultList;
    }

    @Override
    public List<QusetionCategoryVo> questionCategory(QuestionQueryDto queryDto) {

        return null;



    }
}
